
Foreman - Bug #6402

Using "run puppet" feature fails: undefined method `gsub' for #<Array ...>

06/26/2014 09:27 AM - Jon Skarpeteig

Status: Closed   

Priority: Normal   

Assignee: Dominic Cleal   

Category: Puppet integration   

Target version: 1.5.2   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link: 1114639 Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/1603

  

Description

Warning!

undefined method `gsub' for #<Array:0x00000008e13478>

If you feel this is an error with Foreman itself, please open a new issue with Foreman ticketing s

ystem, You would probably need to attach the Full trace and relevant log entries.

NoMethodError

undefined method `gsub' for #<Array:0x00000008e13478>

app/controllers/application_controller.rb:172:in `error'

app/controllers/hosts_controller.rb:193:in `puppetrun'

app/models/concerns/foreman/thread_session.rb:33:in `clear_thread'

lib/middleware/catch_json_parse_errors.rb:9:in `call'

 Log from client:

 puppet-agent[6949]: Forbidden request: foreman(10.0.0.10) access to /run/client.fqdn [save] authe

nticated  at :54

Related issues:

Related to Foreman - Bug #5881: CVE-2014-3491 - XSS from create/update/destro... Closed 05/22/2014

Related to Foreman - Bug #6903: "<br/>" in text when receiving error while de... Closed 08/04/2014

Related to Foreman - Bug #2383: Pushing the "Certificates" button on a smart ... Resolved 04/09/2013

Has duplicate Foreman - Bug #6429: Run Puppet causes Error 500 with message "... Duplicate 06/28/2014

Has duplicate Foreman - Bug #6351: <br /> seen in UI errors when multiple err... Duplicate 06/24/2014

Associated revisions

Revision b4fbdf57 - 07/22/2014 07:00 PM - Dominic Cleal

fixes #6402 - use standard success/error handlers in UI controllers

Revision b9c2c9ff - 07/28/2014 07:28 AM - Dominic Cleal

fixes #6402 - use standard success/error handlers in UI controllers

(cherry picked from commit b4fbdf574faf364fb1fc991c9363b3637ae70906)

History

#1 - 06/26/2014 09:29 AM - Jon Skarpeteig

Should produce a proper error message instead of crashing

#2 - 06/26/2014 04:04 PM - Dominic Cleal

- Related to Bug #5881: CVE-2014-3491 - XSS from create/update/destroy notification boxes added

#3 - 06/26/2014 04:04 PM - Dominic Cleal
- Subject changed from Using "run puppet" feature fails to Using "run puppet" feature fails: undefined method `gsub' for #<Array ...>

- Category set to Puppet integration

#4 - 06/30/2014 03:51 AM - Dominic Cleal

- Has duplicate Bug #6429: Run Puppet causes Error 500 with message "Warning! undefined method `gsub' for #<Array:0x000000091b0608>" added

#5 - 06/30/2014 10:21 AM - Bryan Kearney

- Bugzilla link set to 1114639

#6 - 07/11/2014 11:38 AM - Brian Rak

I also saw this when the foreman-proxy service was stopped, and I attempted to retrieve a certificate list.

Backtrace:

NoMethodError

undefined method `gsub' for #<ActiveRecord::RecordNotFound: ActiveRecord::RecordNotFound>

app/controllers/application_controller.rb:172:in `error'

app/controllers/puppetca_controller.rb:17:in `rescue in index'

app/controllers/puppetca_controller.rb:7:in `index'

app/models/concerns/foreman/thread_session.rb:33:in `clear_thread'

lib/middleware/catch_json_parse_errors.rb:9:in `call'

#7 - 07/15/2014 04:19 PM - Roderick Day

I was just seeing this same behavior with Foreman 1.5.1 and Puppet 3.6.2.  Solved it by adding the following to my client's auth.conf

(/etc/puppet/auth.conf)

1. Allow puppet kick access

path /run

method save

auth any

allow *

"run puppet" feature now works a treat.

#8 - 07/15/2014 04:23 PM - Roderick Day

I should add that in the client log I saw the following:

Tue Jul 15 20:09:29 +0000 2014 Puppet (warning): Denying access: Forbidden request: puppet.example.com(<ip_address>) access to

/run/hostname.example.com [save] authenticated  at :119

Tue Jul 15 20:09:29 +0000 2014 Puppet (err): Forbidden request: puppet.example.com(<ip_address>) access to /run/hostname.example.com [save]

authenticated  at :119

#9 - 07/21/2014 08:54 AM - Dominic Cleal

- Status changed from New to Assigned

- Assignee set to Dominic Cleal

- Target version set to 1.8.0

#10 - 07/21/2014 10:20 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/1603 added

- Pull request deleted ()

#11 - 07/22/2014 08:01 PM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset b4fbdf574faf364fb1fc991c9363b3637ae70906.

#12 - 07/29/2014 05:13 AM - Dominic Cleal

- Has duplicate Bug #6351: <br /> seen in UI errors when multiple errors exist on a resource added
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/b4fbdf574faf364fb1fc991c9363b3637ae70906


#13 - 08/04/2014 06:12 AM - Dominic Cleal

- Related to Bug #6903: "<br/>" in text when receiving error while deleting multiple hosts added

#14 - 09/17/2014 05:33 AM - Dominic Cleal

- Related to Bug #2383: Pushing the "Certificates" button on a smart proxy with disabled PuppetCA throws cryptic ActiveRecord error added
